/*
 * HACK HACK HACK
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "libmadden.h"

struct {
  char *field;
  unsigned long num;
  char *str;
} searches[8];

int main(int argc, char *argv[])
{
  FILE *fd;
  tdb_t *df;
  char data[255], data2[255], dummy;
  unsigned long ldata;

  if (argc < 2)
    return EXIT_FAILURE;

  fd = fopen(argv[1], "r");
  while (!feof(fd)) {
    if (fscanf(fd, "open %s\n", data)) {
      fprintf(stderr, "open %s\n", data);
      df = tdb_open(data, "r+b");
    } else if (fscanf(fd, "table %s\n", data)) {
      fprintf(stderr, "table %s\n", data);
      tdb_open_table(df, data);
    } else if (fscanf(fd, "flush%c\n", &dummy)) {
      fputs("flush\n", stderr);
      tdb_close_table(df);
    } else if (fscanf(fd, "write %s", data)) {
      if (fscanf(fd, "%lu\n", &ldata)) {
        fprintf(stderr, "write %s %lu\n", data, ldata);
        tdb_write(df, data, &ldata);
      } else if (fscanf(fd, "%s\n", data2)) {
        fprintf(stderr, "write %s %s\n", data, data2);
        tdb_write(df, data, data2);
      }
    } else if (fscanf(fd, "search%c", &dummy)) {
      int found = 1, search = 0;

      fputs("search:\n", stderr);
      memset(searches, 0, sizeof(searches));
      while (dummy != '\n' && fscanf(fd, "%s", data)) {
        if (fscanf(fd, "%ld%c", &ldata, &dummy)) {
          searches[search].field = strdup(data);
          searches[search].num = ldata;
          search++;
          fprintf(stderr, "  [%s %ld]\n", data, ldata);
        } else if (fscanf(fd, "%s%c", data2, &dummy)) {
          searches[search].field = strdup(data);
          searches[search].str = strdup(data2);
          search++;
          fprintf(stderr, "  [%s %s]\n", data, data2);
        }
      }

      df->current.cursor_record = 0;	/* FIXME: layer violation */
      do {
        int s;

        found = 0;
        for (s = 0; s < search; s++) {
          int f;
//          fprintf(stderr, "search %d/%d: %s %s %lu = %d\n", s, search, searches[s].field, searches[s].str, searches[s].num, found);
          if (searches[s].str)
            f = tdb_search(df, searches[s].field, (void *)searches[s].str);
          else
            f = tdb_search(df, searches[s].field, (void *)&searches[s].num);
          if (f < 0) {
            fputs("search not found", stderr);
            exit(EXIT_FAILURE);
          }
          found += f;
        }
      } while (found != 0);

      fputs("\n", stderr);
    }
  }
  tdb_close(df);

  return EXIT_SUCCESS;
}
